
;;==================== OSC Master Dispatcher
#include "surmulot-OSC-ports.orc"	
$OSCPORTS(gi_osc_input_port'gi_osc_output_port)
	 
  gSscorefile  =      "$LogFile."

  gi_osc    OSCinit   gi_osc_input_port

instr Master
  kp1	    init      0
  kp2	    init      0
  kp3	    init      0
  kp4	    init      0
  kp5	    init      0
  kp6	    init      0
  kp7	    init      0
  ktime	    timek     
  kseconds  =  ktime / kr
  ktrigger  = int(kseconds * 20) 
	    OSCsend   ktrigger, "", gi_osc_output_port, "/master/time", "f", kseconds
nextmsg:
  kget	    OSClisten	gi_osc, "/master/play", "fffffff", kp1, kp2, kp3, kp4, kp5, kp6, kp7
if (kget == 0) goto ex  
  kdelay    =  kp2 - kseconds  
	    event   "i", "Recorder", kdelay, 0.001, (kdelay >= 0 ? 1 : 0), kp1, kp2, kp3, kp4, kp5, kp6, kp7 
if (kseconds <= kp2) kgoto play
	    kgoto      nextmsg
play:
	    event   "i", kp1, kdelay, kp3, kp4, kp5, kp6, kp7 
	    kgoto     nextmsg
ex:
endin

instr Recorder
if (p4 == 1) goto ok
            fprints   gSscorefile, "%!skipped "
ok:
            fprints   gSscorefile, "i %f %f %f %f %f %f %f\\n", p5, p6, p7, p8, p9, p10, p11
endin

;;====================/ OSC Master Dispatcher
